﻿@using TaskTracker.Extensions;
@model EditIssueViewModel

<div class="offcanvas offcanvas-end w-40" tabindex="-1" id="issue-preview">
    <div class="offcanvas-header">
        <div class="custom-text-update">
            <input type="text" class="form-control issue-preview-title" value="@Model.Issue.Title" onblur="updateIssueTitle(@Model.Issue.Id, this)" />
        </div>
        <button type="button" class="btn-close text-reset" data-bs-dismiss="offcanvas" aria-label="Close"></button>
    </div>
    <div class="offcanvas-body">
        <div class="p-2">
            <div class="row align-items-center mb-3">
                <div class="col-4">Assignee</div>
                <div class="col-6">
                    <div class="issue-preview-assignee" data-bs-toggle="dropdown">
                        <a class="dropdown-item d-flex align-items-center">
                            @await Html.PartialAsync("_UserAvatar", Model.Issue.Assignee)


                            <span class="ms-2 name"> @(Model?.Issue?.Assignee?.Name ?? "Not assigned")</span>
                        </a>
                    </div>
                    <ul class="dropdown-menu w-50" aria-labelledby="dropdownMenuButton">
                        @foreach (var user in Model.FieldValues.Users)
                        {
                            <li>
                                <a class="dropdown-item py-2" onclick="updateIssueAssignee(@Model.Issue.Id, '@user.Id', this)">
                                    @await Html.PartialAsync("_UserAvatar", user)
                                    <span class="ms-2 name"> @user.Name</span>
                                </a>
                            </li>
                        }
                    </ul>

                </div>
            </div>
            <div class="row align-items-center mb-3">
                <div class="col-4">Status</div>
                <div class="col-6">
                    <select class="form-select" onchange="updateIssueProperty(@Model.Issue.Id, 'Status', this.value)">
                        @foreach (var status in Model.FieldValues.Statuses)
                        {
                            <option value="@status.Id"> @status.Description</option>
                        }
                    </select>
                </div>
            </div>
            <div class="row align-items-center mb-3">
                <div class="col-4">Priority</div>
                <div class="col-6">
                    <select class="form-select" onchange="updateIssueProperty(@Model.Issue.Id, 'Priority', this.value)">
                        @foreach (var priority in Model.FieldValues.Priorities)
                        {
                            <option value="@priority.Id"> @priority.Description</option>
                        }
                    </select>
                </div>
            </div>
            <div class="row align-items-center mb-3 d-flex align-items-center">
                <div class="col-4">Due Date</div>
                <div class="col-6">
                    <input name="dueDate" type="text" class="form-control jquery-date-picker w-100" readonly value="@Model.Issue.DueDate.ToDayMonthNameShortString()" onchange="updateIssueProperty(@Model.Issue.Id, 'Due date', this.value)" />
                </div>
            </div>
            <div class="row mb-3">
                <div class="col-4">Description</div>
            </div>
            <div class="mb-3">
                <div class="custom-text-update">
                    <textarea class="form-control issue-preview-description" rows="5" placeholder="What is this task about?" onblur="updateIssueDescription(@Model.Issue.Id, this)">@Model.Issue.Description</textarea>
                </div>
            </div>

            <hr />
            <h4> Comments </h4>
            <div class="custom-text-update mb-4">
                <textarea class="form-control" id="text-comment" rows="4" placeholder="Write a comment..." oninput="showCommentControls()"></textarea>
                <div class="comment-editor-buttons" role="group" style="display: none">
                    <button type="button" class="btn btn-sm bg-primary-subtle text-primary" onclick="addComment(@Model.Issue.Id)">
                        Save
                    </button>
                    <button type="button" class="btn btn-sm btn-light" onclick="clearCommentText()">
                        Discard
                    </button>
                </div>
            </div>
            <div class="position-relative pt-2 comment-section">
                @foreach(var comment in Model.Issue.Comments)
                {
                    @await Html.PartialAsync("_CommentEntry", comment)
                }
            </div>

        </div>
    </div>
</div>